#!/usr/bin/env node
import fs from "fs";
import minimist from "minimist";

import { generate } from "./index";
import log from "./utils/logger";

console.log("\x1b[35m%s\x1b[0m", "\n========== Very-Express-Vue CLI (vex-v) Start ==========\n");

/** configuration process */
const args: minimist.ParsedArgs = minimist(process.argv.slice(2));

/** 
 * ==================== 
 *     CLI Handler
 * ====================
 */

/** Help */
if ( String(args._[0]).toLowerCase() === "h" || args["h"] ) {
    console.log(`Very Express Vue CLI Usage :
vex-v [flag]
    -h : Help
to generate app :
    vex-v [jsonSchemaDir] [outputDir]
    -j : jsonSchemaDir
    -o : outputDir
`);
    process.exit(0);
}

/** Generation */
else {
    if (!fs.existsSync(args.j)) {
        log.error("Schema Dir Not Found:", args.j);
        process.exit(1);
    }

    // run main process
    generate(args.j, args.o);
}

console.log("\x1b[35m%s\x1b[0m", "\n========== Very-Express-Vue CLI (vex-v) Complete ==========\n");
